const moduleAlias = require('module-alias');
moduleAlias.addAlias('@', () => __dirname);


const Koa = require('koa');
const favicon = require('koa-favicon');

require("./db");

const onerror = require('./middleware/onerror');
const header = require('./middleware/header');
const cache = require('./middleware/cache');

const router = require('./router');
const mount = require('koa-mount');

const apiResponseHandler = require('./middleware/api-response-handler');

const app = new Koa();
app.proxy = true;

app.use(favicon(__dirname + '/favicon.png'));

app.use(onerror);

app.context.debug = {
    hitCache: 0,
    request: 0,
    etag: 0,
    paths: [],
    routes: [],
    errorPaths: [],
    errorRoutes: [],
};
app.use(header);
app.use(apiResponseHandler());

app.use(cache(app));
// router
app.use(mount('/', router.routes())).use(router.allowedMethods());

module.exports = app;