require('dotenv').config();
let envs = process.env;
let value;

const calculateValue = () => {
    value = {
        port: envs.PORT || 8080,
        sentry: {
            dsn: envs.SENTRY,
            routeTimeout: parseInt(envs.SENTRY_ROUTE_TIMEOUT) || 30000,
        },
        cache: {
            type: envs.CACHE_TYPE || 'memory',
        },
        mysql: {
            host: envs.MYSQL_HOST || 'localhost',
            port: parseInt(envs.MYSQL_PORT) || 3306,
            username: envs.MYSQL_USERNAME || 'root',
            password: envs.MYSQL_PASSWORD || '123456',
            database: envs.MYSQL_DATABASE || '{{project_name}}',
        },
        allowOrigin: envs.ALLOW_ORIGIN,
        blacklist: envs.BLACKLIST && envs.BLACKLIST.split(','),
        whitelist: envs.WHITELIST && envs.WHITELIST.split(','),
        allowLocalhost: envs.ALLOW_LOCALHOST,
    };
};

calculateValue();

module.exports = {
    set: (env) => {
        envs = Object.assign(process.env, env);
        calculateValue();
    },
    get value() {
        return value;
    },
};
