const fs = require('fs');
const path = require('path');
const base_dir = `${__dirname}/routers`;

const Router = require('@koa/router');
const router = new Router();

const logger = require('./utils/logger');

function addRouter(router_prefix, file_dir) {
    const files = fs.readdirSync(path.join(file_dir, router_prefix));
    files.forEach((file) => {
        if (~file.search(/^[^.].*\.js$/)) {
            const fileName = file.substr(0, file.length - 3);
            const fileEntity = require(path.join(base_dir, router_prefix, file));

            if (fileName !== 'index') {
                router.use("/" + path.join(router_prefix, fileName), fileEntity.routes(), fileEntity.allowedMethods());
            }
        } else {
            const is_dir = fs.lstatSync(path.join(base_dir, router_prefix, file)).isDirectory();
            if (is_dir) {
                addRouter(path.join(router_prefix, file), base_dir);
            }
        }
    });
}

addRouter('', base_dir);

if (process.env.NODE_ENV === 'dev') {
    router.stack.filter((r) => r.methods.length).forEach((r) => {
        logger.warn(`Method: ${r.methods.join('/')} Path: ${r.path}`);
    });
}

module.exports = router;